Attribute VB_Name = "modFileHandling"
Option Explicit

Public Function GenerateFingerprintXML(ByRef bIncludeScanDetails As Boolean) As String
    Dim sFullFingerprint As Concat
        
    Set sFullFingerprint = New Concat

    If (bIncludeScanDetails = True) Then
        sFullFingerprint.Concat "<scan_targethost>" & vbCrLf & scan_targethost & vbCrLf & "</scan_targethost>" & vbCrLf
        sFullFingerprint.Concat "<scan_targetport>" & vbCrLf & scan_targetport & vbCrLf & "</scan_targetport>" & vbCrLf
        sFullFingerprint.Concat "<scan_date>" & vbCrLf & scan_date & vbCrLf & "</scan_date>" & vbCrLf
        sFullFingerprint.Concat "<scan_time>" & vbCrLf & scan_time & vbCrLf & "</scan_time>" & vbCrLf & vbCrLf
    End If
    
    sFullFingerprint.Concat "<" & APP_TESTNAME_GETEXISTING & ">" & vbCrLf & response_getexist & "</" & APP_TESTNAME_GETEXISTING & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_GETLONG & ">" & vbCrLf & response_getlongrequest & "</" & APP_TESTNAME_GETLONG & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_GETNONEXISTING & ">" & vbCrLf & response_get_nonexistent & "</" & APP_TESTNAME_GETNONEXISTING & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_WRONGVERSION & ">" & vbCrLf & response_protocolversion & "</" & APP_TESTNAME_WRONGVERSION & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_HEADEXISTING & ">" & vbCrLf & response_head & "</" & APP_TESTNAME_HEADEXISTING & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_OPTIONS & ">" & vbCrLf & response_options & "</" & APP_TESTNAME_OPTIONS & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_DELETEEXISTING & ">" & vbCrLf & response_delete & "</" & APP_TESTNAME_DELETEEXISTING & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_WRONGMETHOD & ">" & vbCrLf & response_testmethod & "</" & APP_TESTNAME_WRONGMETHOD & ">" & vbCrLf
    sFullFingerprint.Concat "<" & APP_TESTNAME_ATTACKREQUEST & ">" & vbCrLf & response_attackrequest & "</" & APP_TESTNAME_ATTACKREQUEST & ">" & vbCrLf
    
    GenerateFingerprintXML = sFullFingerprint.Value
End Function

Public Sub ReadFingerprintXML(ByRef sFingerprints As String)
    scan_targethost = ExtractFingerprintXML(sFingerprints, "scan_targethost", True)
    scan_targetport = Val(ExtractFingerprintXML(sFingerprints, "scan_targetport", True))
    scan_date = ExtractFingerprintXML(sFingerprints, "scan_date", True)
    scan_time = ExtractFingerprintXML(sFingerprints, "scan_time", True)

    response_attackrequest = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_ATTACKREQUEST)
    response_delete = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_DELETEEXISTING)
    response_getexist = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_GETEXISTING)
    response_getlongrequest = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_GETLONG)
    response_get_nonexistent = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_GETNONEXISTING)
    response_head = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_HEADEXISTING)
    response_options = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_OPTIONS)
    response_testmethod = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_WRONGMETHOD)
    response_protocolversion = ExtractFingerprintXML(sFingerprints, APP_TESTNAME_WRONGVERSION)
End Sub

Public Function ExtractFingerprintXML(ByRef sFingerprints As String, ByRef sTag As String, Optional ByRef bOneLiner As Boolean) As String
    Dim iStart As Integer
    Dim iEnd As Integer
    Dim iContentStart As Integer
    Dim iContentEnd As Integer
    Dim iContentLength As Integer
    Dim iOneLinePosition As Integer
    
    iStart = InStr(1, sFingerprints, "<" & sTag & ">", vbBinaryCompare)
    
    If (iStart > 0) Then
        iContentStart = iStart + (Len(sTag) + 4)
        
        If (iContentStart > 0) Then
            iEnd = InStr(1, sFingerprints, "</" & sTag & ">", vbBinaryCompare)
            
            If (iEnd > iStart) Then
                iContentLength = iEnd - iContentStart
                If (iContentLength > 0) Then
                    If (bOneLiner = True) Then
                        iOneLinePosition = InStr(iContentStart, sFingerprints, vbCrLf, vbBinaryCompare)
                        If (iOneLinePosition) Then
                            ExtractFingerprintXML = Mid$(sFingerprints, iContentStart, iOneLinePosition - iContentStart)
                        Else
                            ExtractFingerprintXML = Mid$(sFingerprints, iContentStart, iContentLength)
                        End If
                    Else
                        ExtractFingerprintXML = Mid$(sFingerprints, iContentStart, iContentLength)
                    End If
                End If
            End If
        End If
    End If
End Function

Public Function StringToFileName(ByRef sString As String) As String
    Dim sOutput As String

    sOutput = Replace(sString, ".", "_", 1, , vbBinaryCompare)
    sOutput = Replace(sOutput, ":", "-", 1, , vbBinaryCompare)
    
    StringToFileName = sOutput
End Function
